/**
 * @author  Arianna Gaio
 *
 */
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Vector;

public class Istance {

/**
 *  This class represent an istance of the Graph Coloring's problem
 *  This problem could be resolve by two different methods:
 *  Backtrack() : this method search the solution by jumping back of one step
 *  Gashing() : this method search the solution by jumping back to the culprit variable
 *
 */
//  variable for an istance
String idIst;
Vector<Node> assignment= new Vector<Node>();
int n; // number of nodes
Statistics s;

Boolean[][] Dp;
int[] latest; //for culprit



public Istance(String problemId) {
//the constructor for Istance will create the Statistic class
	idIst=problemId;
	s=new Statistics(problemId);
	n=0;
	
}



void Backtracking(){
int i=0; //inizialize variable counter
Dp=new Boolean[n][assignment.get(i).domain.size];

//copy domain
for (int c=0; c<assignment.get(i).domain.size; c++)
Dp[i][c]=assignment.get(i).domain.dom[c];

while (i>=0 && i<n){
	
			int x=SelectValue(i);
			 assignment.get(i).solution=x;
			if (x==-1)   //no value was returned
			{
				i=i-1; //backtrak
			    s.jumpB=s.jumpB+1;
			 }else{	
			  
			   i=i+1; //step forward
			   
			   if (i<n) //copy domain
			   {
				   for (int c=0; c<assignment.get(i).domain.size; c++)
					   Dp[i][c]=assignment.get(i).domain.dom[c];
			   }
			}	
 }
	if (i<0)
		System.out.println("no solution!");
	else
	{	System.out.println("solution found!");
		s.solutionB=true;
	}
}


private int SelectValue(int x) {
	int l=0;
	while (l<assignment.get(x).domain.dom.length){ //choose arbitray value
		if (Dp[x][l]==false)		
			l=l+1;
		else{
			Dp[x][l]=false;	
			if (consistent(assignment,x,l)) //consistent(ai-1, xi=a)
				return l;
			else l=l+1;
	
		}
	
	}
	return -1;
	

}


private boolean consistent(Vector<Node> solution, int x, int a) {
	//return true if (r=ai-1, xi=a) is consistent
	for (int prev=0; prev<x; prev++){
		if ( solution.get(x).conflict.get(prev) && solution.get(prev).solution==a)
			return false;
		
	}
	return true;
}

void Gaschnig(){
	int i=0; //inizialize variable counter
	Dp=new Boolean[n][assignment.get(i).domain.size];
	latest =new int[n];


	//copy domain
	for (int c=0; c<assignment.get(i).domain.size; c++)
		Dp[i][c]=assignment.get(i).domain.dom[c];

	latest[i]=0; // initialize pointer to culprit
	
	while (i>=0 && i<n){
		int x=SelectValueGBJ(i);
		 assignment.get(i).solution=x;
		if (x==-1)   //no value was returned
		{	
			if (i>0){		
			i=latest[i]; //backjump
		    s.jumpG=s.jumpG+1;}
			else i=-1;		//no solution
		 }else{	
		  
			 i=i+1; //step forward
		   if (i<n) //copy domain
		   {
			   for (int c=0; c<assignment.get(i).domain.size; c++)
				   Dp[i][c]=assignment.get(i).domain.dom[c];
		  
			   latest[i]=0;
		   }
		  
		}
	}
	if (i<0)
		System.out.println("no solution!");
	else
	{	System.out.println("solution found!");
		s.solutionG=true;
	}
}

private int SelectValueGBJ(int x) {
	int k,l=0;
	
	Boolean consistent=false;
	while (l<Dp[x].length){ 
		if (Dp[x][l]==false)		//while Dp' is not empty
			l=l+1;
		else{
			Dp[x][l]=false;		//choose arbitray value
			consistent=true;
			k=0;
			while(k<x && consistent){
				if (k>latest[x])
					latest[x]=k;
		
				if (!consistentGBJ(k,x,l)) //consistent(ak, xi=a)
					consistent=false;
			else k=k+1;
			}
			if (consistent)
			return l;
	
		}
	
	}
	return -1;
	
}



private boolean consistentGBJ(int k, int j, int l) {
	if (assignment.get(k).solution==l && assignment.get(j).conflict.get(k))
	return false;
	
	return true;
}




// GET MEHTODS
public boolean getConflict(int x, int z) {
// return true if there is a contrsaint between x and z
	return assignment.get(x).conflict.get(z);
	
}



// SET MEHTODS
public void delete_domain(int x, int col) {
// set false to the color's domain variable for node x
	assignment.get(x).domain.dom[col]=false;
	
}

public void setTimeB(long l) {
	//for save statistics
	s.timeB=l;
}
public void setTimeG(long l) {
	//for save statistics
	s.timeG=l;
}
public void addNode(Node node) {
	assignment.add(node);		
	n=n+1;
}
void addConstraint(int a, int b){
//  a should be previous than b in the assignment vector's order
 	if (a<b)
	assignment.get(b).conflict.set(a, true);
	else
	assignment.get(a).conflict.set(b, true);

}




public void saveStatistic(PrintWriter outputFile) throws FileNotFoundException {
	s.showStatistic(outputFile, n);
}
}
